package com.ruoyi.web.v2.v1.controller;


import com.ruoyi.common.core.domain.AjaxResult;
import com.ruoyi.web.v2.v1.model.JsMaterial;
import com.ruoyi.web.v2.v1.service.IJsMaterialService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.Map;

import static com.ruoyi.common.core.domain.AjaxResult.success;

/**
 * <p>
 * v2.0物料管理 前端控制器
 * </p>
 *
 * @author author
 * @since 2025-05-21
 */
@RestController
@RequestMapping("/js-material")
@Api("2.0物料管理")
public class JsMaterialController {

    @Autowired
    private IJsMaterialService materialService;

    @ApiOperation("物料管理添加")
    @PostMapping("/add")
    public AjaxResult add(@RequestBody JsMaterial material){
        return materialService.add(material);
    }

    @ApiOperation("物料管理修改")
    @PostMapping("/edit")
    public AjaxResult edit(@RequestBody JsMaterial material){
        return materialService.edit(material);
    }

    @ApiOperation("物料管理删除")
    @PostMapping("/delete")
    public AjaxResult delete(@RequestBody Map<String, String> paramsMap) {
        String ids = paramsMap.get("ids");
        return materialService.delete(ids);
    }

    @ApiOperation("物料管理列表")
    @PostMapping("/list")
    public AjaxResult listAll(){
        return materialService.listAll();
    }

    @ApiOperation("物料管理分页")
    @GetMapping("/page")
    public AjaxResult page(@RequestParam("pageNum") Integer pageNum, @RequestParam("pageSize") Integer pageSize
            , @RequestParam(value = "materialName", required = false) String materialName
            ,@RequestParam(value = "materialType", required = false) Integer materialType
            ,@RequestParam(value = "needAllFlag", required = false) Boolean needAllFlag) {
        return materialService.page(pageNum, pageSize, materialName,materialType,needAllFlag);
    }

    @ApiOperation("物料管理详情")
    @PostMapping("/listById")
    public AjaxResult listById(@RequestBody Map<String, String> paramsMap){
        String id = paramsMap.get("id");
        return success(materialService.getById(id));
    }
}
